# CHANGELOG

### [0.3.0] - 2022-11-16
* Реализовал генерацию и ренедеринг OpenAPI схемы.
    - Сейчас доступна только JSON схема (/openapi.json) и redoc (/docs) рендеринг.
    - Генерация самая базовая. Только пути, методы и заглушка успешного ответа.
* Исправил ошибку из-за которой стэк миддлвар не перестраивался при добавлении новой методом `add_middleware`.
* Добавли проверку пути для монтируемого приложения/роутера.
* Поправил type hinting'и в модулях app, endpoint.
* Поправил конфиг для генерации документации.
* Перешёл на pyproject вместо setup.
* Поправил README и LICENSE.


### [0.2.0] - 2021-12-07

* Исправил серьезную недоработку связанную с установкой поля request и websocket у endpoint'а. Такой подход мог приводить к тому, что даже при небольшой нагрузке, если перед обработкой запроса была небольшая задержка (например обращение к БД), следующие за ним запросы переустанавливали поле, следовательно, предыдущий объект запроса просто "терялся" и не был обработан.
    - Решением проблемы стало возвращение к проверенной схеме с передачей объекта запроса в сам метод.
    - Вместо запроса endpoint'у устанавливается поле с самим приложением. Предварительно происходит проверка, что этого поля ещё у него нет, а в scope у запроса есть объект приложения.
* Изменил метод, вызываемый у веб-сокет endpoint'а. `call` вместо `__call__`
* Доработаны тесты и документация.


### [0.1.2] - **[YANKED]** - 2021-11-02

* Доработал объявление HTTP роутов для эндпоинтов классов (CBV). Если список методов не передан, вместо стандарных (GET, HEAD), список будет сформирован на основе объявленных в классе методов.
* Ошибка валидации входящих параметров (ValidationError) от pydantic'а. Теперь "оборачивается" в HTTPValidationError и райзится наружу, где ловится обработчиком исключений.
    * Дефолтный обработчик делает тоже самое, что до этого происходило внутри эндпоинта, форматирует ошибку в JSON.
    * Такая реализация позволит пользователю переопределить механизм обработки исключения.
* В приложении добавил метод установки _списка роутов_. В некоторых случаях удобно установить все роуты после инициализации самого приложения.
* Добавил модуль со стандартными шаблонами-ответами HTTP кодов.
* Доработал тесты и дополнил документацию.


### [0.1.1] - **[YANKED]** - 2021-09-01

* Добавлена документация.
* Добавлены модули requests, responses для единообразных импортов.
* Сделал приложение dict-like объектом.


### [0.1.0] - 2021-07-09

* Проект получил новое имя - [Хиус (Hius)](https://ru.wikipedia.org/wiki/%D0%A5%D0%B8%D1%83%D1%81_(%D0%BF%D0%BB%D0%B0%D0%BD%D0%B5%D1%82%D0%BE%D0%BB%D1%91%D1%82)).
* Реализовал валидацию входящих параметров запроса и передачу их в метод (спасибо `pydantic`).
    * Валидация происходит только тех параметров, что будут указаны аргументами функции, где их ожидают получить.
    * Если валидация не прошла:
        * Для HTTP запроса. Вернётся json со статус-кодом 400 (Bad Request), сформированный pydantic'ом и указывающий на то, какие параметры не удовлетворяют условиям успешной проверки.
        * Для websocket запроса. Соединение будет сразу же разорвано.

### [0.0.4] - 2021-06-01

* Реализовал поддержку lifespan протокола.
    * Возможность передать/декорировать множество lifespan-генераторов.
    * Методы/генераторы, вызываемые при запуске/остановке приложения, получают один единственный аргумент - само приложение.
* Добавил явную проверку типа передаваемого массива с методами при установке роута.
* Убрал возможность передать в приложение готовый роутер.
* Несколько мелких баг-фиксов и рефакторинг.

### [0.0.3] - 2021-05-31

* Добавлен метод `url_path_for` для получения URL'а ресурса внутри приложения.
    * Добавлен класс помогающий собрать URL. Представляет собой прокаченную версию класса `URLPath` из starlette.
    * Парсер пути теперь возвращает "шаблона" пути для подстановки параметров. Необходим для сборки URL'а.
* Ещё раз реорганизовал роутер, отделив друг от друга http и websocket роуты и методы.
* Метод `_handle`  класса `BaseEndpoint` теперь принимает и передаёт для выполнения неограниченное кол-во аргументов.
* Исправил выполнение websocket запроса в `WebsocketClassEndpoint`.
* Удалил обёртку `AttrScope`.

### [0.0.2] - 2021-05-24

* Реорганизация роутера.
* Добавлена возможность установки websocket роутов.


### [0.0.1] - 2021-05-18

* Набросок приложения и роутера.
